include(Resources.idRelative("mtr:lib/harrys_lib.js"));


var renderWindows = true;

var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:bvg_h/bvg_h_head.obj"), null);
var models = uploadPartedModels(rawModels, true, true);

var rawModels2 = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:bvg_h/graffity.obj"), null);
var graffityModel = uploadGrafModel(rawModels2);

var rawModels3 = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:bvg_h/bvg_h_mid.obj"), null);
var models2 = uploadPartedModels(rawModels3, true, true);

var rawModels4 = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:bvg_h/graffity_mid.obj"), null);
var graffityModel2 = uploadGrafModel(rawModels4);

var grafCount = 5;

include("mtr:number/bvg_num_h.js");

function uploadGrafModel(rawModels) {
	let grafCount = 5; // бодрый я, пожалуйста, разберись почему когда я пишу эту переменную в глобальной среде - оно не жрет в цикле фор???
					// сообщение от бодрого меня - нет, не разберусь :)
	print("starting registering grafs");
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {

		entry = it.next();
		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		entry.getValue().applyUVMirror(false, true);
		result[jsStringKey] = {}
		let og = ModelManager.uploadVertArrays(entry.getValue());
		for (let i = 0; i < grafCount; i++) {
			let copy = og.copyForMaterialChanges();
			copy.replaceAllTexture(Resources.idRelative("mtr:bvg_h/grafs/"+i+".png"))
			result[jsStringKey]["" + i] = copy;

		}
		print(jsStringKey)
		
		
	}
	
	return result;
}

function create(ctx, state, train) {

	initRoll(train, state);
	initRocking(train, state);

	state.postCreateFunctionCalled = false;

	state.wipeCoef = 0.0;
	state.wipeReverseMark = 0; // метка для плавного переключения дворников

	state.extDoorLightTimer = 0.0;
	state.extDoorLightFlag = false;
	state.oldDoorVal = train.doorValue();
	state.extDoorLightLeftMemory = new Array(train.trainCars());
	state.extDoorLightRightMemory = new Array(train.trainCars());

	state.hasGraf = false;
	state.number = Math.abs(train.id() % 1000) + 5000; // default value

	state.grafTypes = [];
	state.grafShouldBeArray = [];

	for (let i = 0; i < train.trainCars(); i++) {
		// door memory
		state.extDoorLightLeftMemory[i] = train.doorLeftOpen[i];
		state.extDoorLightRightMemory[i] = train.doorRightOpen[i];

		// graffity vars
		state.grafTypes[i] = 0;
		state.grafShouldBeArray[i] = false;
	}
}


function dispose(ctx, state, train) {

}

function render(ctx, state, train) {
	setPostcreateInfo(ctx, state, train); // train.siding() при вызове в функции create возвращает null, поэтому нужна доп. проверка.
	updateLogic(state, train);
	renderLogic(ctx, state, train);
}



function setPostcreateInfo(ctx, state, train) {
	if (!state.postCreateFunctionCalled) {
		
		if (train.siding() == null) {
			return;
		}

		let infoArr = train.siding().name.split('\\|');
		let num = parseInt("" + infoArr[1]);
		let graf = infoArr[2] == '1';

		//let grafCount = 3; 
	
		state.hasGraf = graf;
		state.number = isNaN(num) ? state.number : num;
		state.grafTypes = [];
		state.grafShouldBeArray = [];
		
		var rand = new java.util.Random(train.id());
		for (var i = 0; i < train.trainCars(); i++) {
			if (Math.abs(rand.nextInt()) % 4 == 0) {
				state.grafShouldBeArray[i] = false;
				state.grafTypes[i] = 0;
			} else {
				state.grafShouldBeArray[i] = true;
				state.grafTypes[i] = Math.abs(rand.nextInt()) % grafCount;
			}
			
		}
		
		state.postCreateFunctionCalled = true;
	}
}

function updateLogic(state, train) {
	updateRoll(train, state, -0.5);
	updateRocking(train, state, 140, 88, 20, 27);
	updateWipers(train, state);
	updateExtLights(train, state);
}

function updateExtLights(train, state) {
	if (train.doorValue() > 0.0 && train.doorValue() < 1.0 && state.oldDoorVal > train.doorValue()) {
		if (!state.extDoorLightFlag) {
			state.extDoorLightTimer = 9.0;
			for (let i = 0; i < train.trainCars(); i++) {
				state.extDoorLightLeftMemory[i] = train.doorLeftOpen[i];
				state.extDoorLightRightMemory[i] = train.doorRightOpen[i];
			}
		}
		state.extDoorLightFlag = true;
	}

	if (state.extDoorLightTimer > 0) {
		state.extDoorLightTimer -= Timing.delta();
	}

	if (state.extDoorLightTimer <= 0) {
		state.extDoorLightTimer = 0;
		state.extDoorLightFlag = false;
	} 

	state.oldDoorVal = train.doorValue();
}

function updateWipers(train, state) {
	let pos = train.lastCarPosition[0];
	let isRaining = MinecraftClient.worldIsRainingAt(pos);
	if (isRaining || state.wipeCoef > 0) {
		state.wipeCoef += Timing.delta() / 1.5;
		if (state.wipeCoef > 1.0) {
			state.wipeCoef = 0.0;
			state.wipeReverseMark = train.isReversed();
		}
	}
}

function renderLogic(ctx, state, train) {
	let matrices = new Matrices();
	renderHead(ctx, state, train, 0, matrices);

	for (var i = 1; i < train.trainCars() - 1; i++) {
		renderMid(ctx, state, train, i, matrices);
	}
	if (train.trainCars() > 1) {
		renderTail(ctx, state, train, train.trainCars()-1, matrices);
	}
}

function renderHead(ctx, state, train, i, matrices) {
	let isGraf = state.hasGraf && state.grafShouldBeArray[i];
	let grafType = state.grafTypes[i] + "";

	let roll = state.rolls[i];
	roll = clamp(roll, -0.03, 0.03);
	let speedKmph = train.speed() * 20 * 3.6;
	let speedCoef = speedKmph > 20.0 ? 1.0 : speedKmph / 40 + 0.5;
	let rockZ = (state.rockingZCoef) % 1.0;
	let totalZrotation = speedCoef * chaoticRotate2(rockZ) * 3 + roll;

	let renderFrontLights = !train.isReversed();

	let isLeftOpened = train.doorLeftOpen[i];
	let isRightOpened = train.doorRightOpen[i];
	let doorValue = train.doorValue();
	let shouldRenderL = !train.isDoorOpening() && doorValue < 1 && isLeftOpened && (doorValue % 0.2) > 0.09; 
	let shouldRenderR = !train.isDoorOpening() && doorValue < 1 && isRightOpened && (doorValue % 0.2) > 0.09; 

	ctx.drawCarModel(models["BOGIES"], i, matrices);
	
	matrices.pushPose();
	matrices.rotateZ(totalZrotation);

	numRenderHHeadFront(ctx, train, state, matrices, i);
	numRenderHHeadSide(ctx, train, state, matrices, i);

	if (isGraf) {
		ctx.drawCarModel(graffityModel["EXT"][grafType], i, matrices);
	}

	ctx.drawCarModel(state.dh.model, i, matrices);

	ctx.drawCarModel(models["EXT"], i, matrices);
	ctx.drawCarModel(models["INT"], i, matrices);
	ctx.drawCarModel(models["CAB"], i, matrices);
	ctx.drawCarModel(models["LAMPS"], i, matrices);
	//FARY
	if (renderFrontLights) {
		ctx.drawCarModel(models["FARY"], i, matrices);
	} else {
		ctx.drawCarModel(models["BUF"], i, matrices);
	}
	//WINDOWS
	if (renderWindows) {
		ctx.drawCarModel(models["WINDOWS"], i, matrices);
		ctx.drawCarModel(models["WINDOWS_INT"], i, matrices);
	}
	//EXTERIOR DOOR INDICATORS
	if (shouldRenderL) {
		ctx.drawCarModel(models["LIGHT_L"], i, matrices);
	}
	if (shouldRenderR) {
		ctx.drawCarModel(models["LIGHT_R"], i, matrices);
	}
	//DOORS
	renderDoorHalf(ctx, train, state, i, matrices, models["D_RR_INT"], models["D_RR_EXT"],
		models["D_RR_WIN"], null, graffityModel["DOOREXT_LL"][grafType], 0.04, 0.08, 0, 0.64, false)

	renderDoorHalf(ctx, train, state, i, matrices, models["D_RL_INT"], models["D_RL_EXT"],
		models["D_RL_WIN"], models["D_RL_LIGHT"], graffityModel["DOOREXT_LR"][grafType], 0.04, -0.08, 0, -0.64, false)

	renderDoorHalf(ctx, train, state, i, matrices, models["D_LR_INT"], models["D_LR_EXT"],
		models["D_LR_WIN"], null, graffityModel["DOOREXT_RR"][grafType], -0.04, -0.08, 0, -0.64, true)

	renderDoorHalf(ctx, train, state, i, matrices, models["D_LL_INT"], models["D_LL_EXT"],
		models["D_LL_WIN"], models["D_LL_LIGHT"], graffityModel["DOOREXT_RL"][grafType], -0.04, 0.08, 0, 0.64, true)
	//WIPERS

	let coef = !state.wipeReverseMark ? state.wipeCoef : 0.0;

	matrices.pushPose();
	matrices.translate(-0.7797, 2.024, 8.039);
	matrices.rotate(-0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef))
	matrices.translate(0.7797, -2.024, -8.039);
	{
		matrices.pushPose();
		matrices.translate(-0.5089, 1.478, 8.157);
		matrices.rotate(-0.0679345, 0.130434, 0.989127, 0.95 * wipFunc(coef));
		matrices.translate(0.5089, -1.478, -8.157);
		ctx.drawCarModel(models["EXT.004"], i, matrices);
		ctx.drawCarModel(models["EXT.003"], i, matrices);
		{
			matrices.pushPose();
			matrices.translate(-0.4720, 1.479, 8.160);
			matrices.rotate(-0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef));
			matrices.translate(0.4720, -1.479, -8.160);
			ctx.drawCarModel(models["EXT.002"], i, matrices);
			matrices.popPose();
		}
		matrices.popPose();
	}
	ctx.drawCarModel(models["EXT.001"], i, matrices);
	matrices.popPose();


	matrices.pushPose();
	matrices.translate(0.08412, 2.028, 8.067);
	matrices.rotate(0, 0.130434, 0.989127, -0.95 * wipFunc(coef))
	matrices.translate(-0.08412, -2.028, -8.067);
	{
		matrices.pushPose();
		matrices.translate(0.3555, 1.479, 8.164);
		matrices.rotate(0, 0.130434, 0.989127, 0.95 * wipFunc(coef));
		matrices.translate(-0.3555, -1.479, -8.164);
		ctx.drawCarModel(models["EXT.008"], i, matrices);
		ctx.drawCarModel(models["EXT.007"], i, matrices);
		{
			matrices.pushPose();
			matrices.translate(0.3930, 1.479, 8.164);
			matrices.rotate(0, 0.130434, 0.989127, -0.95 * wipFunc(coef));
			matrices.translate(-0.3930, -1.479, -8.164);
			ctx.drawCarModel(models["EXT.006"], i, matrices);
			matrices.popPose();
		}
		matrices.popPose();
	}
	ctx.drawCarModel(models["EXT.005"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0.8001, 2.023, 8.038);
	matrices.rotate(0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef))
	matrices.translate(-0.8001, -2.023, -8.038);
	{
		matrices.pushPose();
		matrices.translate(1.070, 1.469, 8.108);
		matrices.rotate(0.0679345, 0.130434, 0.989127, 0.95 * wipFunc(coef));
		matrices.translate(-1.070, -1.469, -8.108);
		ctx.drawCarModel(models["EXT.012"], i, matrices);
		ctx.drawCarModel(models["EXT.011"], i, matrices);
		{
			matrices.pushPose();
			matrices.translate(1.107, 1.469, 8.104);
			matrices.rotate(0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef));
			matrices.translate(-1.107, -1.469, -8.104);
			ctx.drawCarModel(models["EXT.010"], i, matrices);
			matrices.popPose();
		}
		matrices.popPose();
	}
	ctx.drawCarModel(models["EXT.009"], i, matrices);
	matrices.popPose();

	matrices.popPose();
}

function renderMid(ctx, state, train, i, matrices) {
	let roll = state.rolls[i];
	roll = clamp(roll, -0.03, 0.03);
	let speedKmph = train.speed() * 20 * 3.6;
	let speedCoef = speedKmph > 20.0 ? 1.0 : speedKmph / 40 + 0.5;
	let rockZ = (state.rockingZCoef) % 1.0;
	let totalZrotation = speedCoef * chaoticRotate2(rockZ) * 3 + roll;

	let renderFrontLights = !train.isReversed();

	let isGraf = state.hasGraf && state.grafShouldBeArray[i];
	let grafType = state.grafTypes[i] + "";

	let isLeftOpened = train.doorLeftOpen[i];
	let isRightOpened = train.doorRightOpen[i];
	let doorValue = train.doorValue();
	let shouldRenderL = !train.isDoorOpening() && doorValue < 1 && isLeftOpened && (doorValue % 0.2) > 0.09; 
	let shouldRenderR = !train.isDoorOpening() && doorValue < 1 && isRightOpened && (doorValue % 0.2) > 0.09; 

	ctx.drawCarModel(models2["BOGIES"], i, matrices);
	
	matrices.pushPose();
	matrices.rotateX(0.0005);
	matrices.rotateZ(totalZrotation);

	if (isGraf) {
		ctx.drawCarModel(graffityModel2["EXT"][grafType], i, matrices);
	}


	numRenderHMid(ctx, train, state, matrices, i);

	ctx.drawCarModel(models2["EXT"], i, matrices);
	ctx.drawCarModel(models2["INT"], i, matrices);
	ctx.drawCarModel(models2["LAMPS"], i, matrices);

	//WINDOWS
	if (renderWindows) {
		ctx.drawCarModel(models2["WINDOWS"], i, matrices);
		ctx.drawCarModel(models2["WINDOWS_INT"], i, matrices);
	}
	//EXTERIOR DOOR INDICATORS
	if (shouldRenderL) {
		ctx.drawCarModel(models2["LIGHT_L"], i, matrices);
	}
	if (shouldRenderR) {
		ctx.drawCarModel(models2["LIGHT_R"], i, matrices);
	}
	//DOORS

	renderDoorHalf(ctx, train, state, i, matrices, models2["D_RR_INT"], models2["D_RR_EXT"],
		models2["D_RR_WIN"], null, graffityModel2["DOOREXT_LL"][grafType], 0.04, 0.08, 0, 0.64, false)

	renderDoorHalf(ctx, train, state, i, matrices, models2["D_RL_INT"], models2["D_RL_EXT"],
		models2["D_RL_WIN"], models2["D_RL_LIGHT"], graffityModel2["DOOREXT_LR"][grafType], 0.04, -0.08, 0, -0.64, false)

	renderDoorHalf(ctx, train, state, i, matrices, models2["D_LR_INT"], models2["D_LR_EXT"],
		models2["D_LR_WIN"], null, graffityModel2["DOOREXT_RR"][grafType], -0.04, -0.08, 0, -0.64, true)

	renderDoorHalf(ctx, train, state, i, matrices, models2["D_LL_INT"], models2["D_LL_EXT"],
		models2["D_LL_WIN"], models2["D_LL_LIGHT"], graffityModel2["DOOREXT_RL"][grafType], -0.04, 0.08, 0, 0.64, true)

	matrices.popPose();
}

function renderTail(ctx, state, train, i, matrices) {
	let roll = state.rolls[i];
	roll = clamp(roll, -0.03, 0.03);
	let speedKmph = train.speed() * 20 * 3.6;
	let speedCoef = speedKmph > 20.0 ? 1.0 : speedKmph / 40 + 0.5;
	let rockZ = (state.rockingZCoef) % 1.0;
	let totalZrotation = speedCoef * chaoticRotate2(rockZ) * 3 + roll;

	let renderFrontLights = !train.isReversed();

	let isGraf = state.hasGraf && state.grafShouldBeArray[i];
	let grafType = state.grafTypes[i] + "";

	let isLeftOpened = train.doorLeftOpen[i];
	let isRightOpened = train.doorRightOpen[i];
	let doorValue = train.doorValue();
	let shouldRenderR = !train.isDoorOpening() && doorValue < 1 && isLeftOpened && (doorValue % 0.2) > 0.09; 
	let shouldRenderL = !train.isDoorOpening() && doorValue < 1 && isRightOpened && (doorValue % 0.2) > 0.09; 

	ctx.drawCarModel(models["BOGIES"], i, matrices);
	
	matrices.pushPose();

	matrices.rotateX(0.0005);
	matrices.rotateZ(totalZrotation);
	matrices.rotateY(3.1415);

	if (isGraf) {
		ctx.drawCarModel(graffityModel["EXT"][grafType], i, matrices);
	}

	numRenderHHeadFront(ctx, train, state, matrices, i);
	numRenderHHeadSide(ctx, train, state, matrices, i);

	ctx.drawCarModel(state.dh.model, i, matrices);

	ctx.drawCarModel(models["EXT"], i, matrices);
	ctx.drawCarModel(models["INT"], i, matrices);
	ctx.drawCarModel(models["CAB"], i, matrices);
	ctx.drawCarModel(models["LAMPS"], i, matrices);
	//FARY
	if (!renderFrontLights) {
		ctx.drawCarModel(models["FARY"], i, matrices);
	} else {
		ctx.drawCarModel(models["BUF"], i, matrices);
	}
	//WINDOWS
	if (renderWindows) {
		ctx.drawCarModel(models["WINDOWS"], i, matrices);
		ctx.drawCarModel(models["WINDOWS_INT"], i, matrices);
	}
	//EXTERIOR DOOR INDICATORS
	if (shouldRenderL) {
		ctx.drawCarModel(models["LIGHT_L"], i, matrices);
	}
	if (shouldRenderR) {
		ctx.drawCarModel(models["LIGHT_R"], i, matrices);
	}
	//DOORS
	renderDoorHalf(ctx, train, state, i, matrices, models["D_RR_INT"], models["D_RR_EXT"],
		models["D_RR_WIN"], null, graffityModel["DOOREXT_LL"][grafType], 0.04, 0.08, 0, 0.64, true)

	renderDoorHalf(ctx, train, state, i, matrices, models["D_RL_INT"], models["D_RL_EXT"],
		models["D_RL_WIN"], models["D_RL_LIGHT"], graffityModel["DOOREXT_LR"][grafType], 0.04, -0.08, 0, -0.64, true)

	renderDoorHalf(ctx, train, state, i, matrices, models["D_LR_INT"], models["D_LR_EXT"],
		models["D_LR_WIN"], null, graffityModel["DOOREXT_RR"][grafType], -0.04, -0.08, 0, -0.64, false)

	renderDoorHalf(ctx, train, state, i, matrices, models["D_LL_INT"], models["D_LL_EXT"],
		models["D_LL_WIN"], models["D_LL_LIGHT"], graffityModel["DOOREXT_RL"][grafType], -0.04, 0.08, 0, 0.64, false)
	//WIPERS

	let coef = state.wipeReverseMark ? state.wipeCoef : 0.0;

	matrices.pushPose();
	matrices.translate(-0.7797, 2.024, 8.039);
	matrices.rotate(-0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef))
	matrices.translate(0.7797, -2.024, -8.039);
	{
		matrices.pushPose();
		matrices.translate(-0.5089, 1.478, 8.157);
		matrices.rotate(-0.0679345, 0.130434, 0.989127, 0.95 * wipFunc(coef));
		matrices.translate(0.5089, -1.478, -8.157);
		ctx.drawCarModel(models["EXT.004"], i, matrices);
		ctx.drawCarModel(models["EXT.003"], i, matrices);
		{
			matrices.pushPose();
			matrices.translate(-0.4720, 1.479, 8.160);
			matrices.rotate(-0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef));
			matrices.translate(0.4720, -1.479, -8.160);
			ctx.drawCarModel(models["EXT.002"], i, matrices);
			matrices.popPose();
		}
		matrices.popPose();
	}
	ctx.drawCarModel(models["EXT.001"], i, matrices);

	matrices.popPose();


	matrices.pushPose();
	matrices.translate(0.08412, 2.028, 8.067);
	matrices.rotate(0, 0.130434, 0.989127, -0.95 * wipFunc(coef))
	matrices.translate(-0.08412, -2.028, -8.067);
	{
		matrices.pushPose();
		matrices.translate(0.3555, 1.479, 8.164);
		matrices.rotate(0, 0.130434, 0.989127, 0.95 * wipFunc(coef));
		matrices.translate(-0.3555, -1.479, -8.164);
		ctx.drawCarModel(models["EXT.008"], i, matrices);
		ctx.drawCarModel(models["EXT.007"], i, matrices);
		{
			matrices.pushPose();
			matrices.translate(0.3930, 1.479, 8.164);
			matrices.rotate(0, 0.130434, 0.989127, -0.95 * wipFunc(coef));
			matrices.translate(-0.3930, -1.479, -8.164);
			ctx.drawCarModel(models["EXT.006"], i, matrices);
			matrices.popPose();
		}
		matrices.popPose();
	}
	ctx.drawCarModel(models["EXT.005"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0.8001, 2.023, 8.038);
	matrices.rotate(0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef))
	matrices.translate(-0.8001, -2.023, -8.038);
	{
		matrices.pushPose();
		matrices.translate(1.070, 1.469, 8.108);
		matrices.rotate(0.0679345, 0.130434, 0.989127, 0.95 * wipFunc(coef));
		matrices.translate(-1.070, -1.469, -8.108);
		ctx.drawCarModel(models["EXT.012"], i, matrices);
		ctx.drawCarModel(models["EXT.011"], i, matrices);
		{
			matrices.pushPose();
			matrices.translate(1.107, 1.469, 8.104);
			matrices.rotate(0.0679345, 0.130434, 0.989127, -0.95 * wipFunc(coef));
			matrices.translate(-1.107, -1.469, -8.104);
			ctx.drawCarModel(models["EXT.010"], i, matrices);
			matrices.popPose();
		}
		matrices.popPose();
	}
	ctx.drawCarModel(models["EXT.009"], i, matrices);
	matrices.popPose();

	matrices.popPose();
}





function renderDoorHalf(ctx, train, state, i, matrices, ext, int, win, light, graf, x1, z1, x2, z2, isRight) {
	let doorValue = 0.0
	if (isRight) {
		doorValue = train.doorValue() * train.doorRightOpen[i];
	} else {
		doorValue = train.doorValue() * train.doorLeftOpen[i];
	}

	let doorValueClamped = clamp(doorValue * 1.7, 0, 1);

	let doorA = 0.0
	let doorB = 0.0
	const alpha = 0.3

	if (doorValueClamped < alpha) {
		doorB = 0.0
		doorA = doorValueClamped / alpha
	} else {
		doorB = (doorValueClamped - alpha) / (1 - alpha)
		doorA = 1.0
	}

	let isOpenedMem = !isRight ? state.extDoorLightLeftMemory[i] : state.extDoorLightRightMemory[i];
	let shouldRenderExtLight = isOpenedMem && (state.extDoorLightTimer % 0.75) > 0.4 && state.extDoorLightFlag; 

	doorA = easeIn(doorA)
	doorB = easeOut(doorB)

	matrices.pushPose();
	matrices.translate(x1 * doorA, 0 ,z1 * doorA * doorA);
	matrices.translate(x2 * doorB, 0 ,z2 * doorB);
	ctx.drawCarModel(ext, i, matrices);
	ctx.drawCarModel(int, i, matrices);
	let grafMark = state.hasGraf && state.grafShouldBeArray[i];

	if (grafMark){
		ctx.drawCarModel(graf, i, matrices);
	}

	if (renderWindows) {
		ctx.drawCarModel(win, i, matrices);
	}

	if (light != null && shouldRenderExtLight) {
		ctx.drawCarModel(light, i, matrices);
	}
	matrices.popPose();
}


function wipFunc(x) {
	return 0.5 * pseudoSin(x + 0.75) + 0.5;
}



function easeIn(x) {
	return x*x;
}

function easeOut(x) {
	return 1 - (1 - x) * (1 - x);
}

function chaoticRotate(x) {
	return (x)*(x-1)*(x-0.25)*(x-0.6)*(x-0.8);
}

function chaoticRotate2(x) {
	return (x)*(x-1)*(x-0.15)*(x-0.5)*(x-0.8);
}

