include(Resources.idRelative("mtr:lib/harrys_lib.js"));

//include("display.js");


var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:f79/bvg.obj"), null);
var models = uploadPartedModels(rawModels, true, true);

var rawModels2 = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:f79/bogie.obj"), null);
var bogieModel = uploadPartedModels(rawModels2, true, true);

var rawModels3 = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:f79/graffity.obj"), null);
var graffityModel = uploadGrafModel(rawModels3);

var grafCount = 3;

include("mtr:number/bvg_num.js");

function uploadGrafModel(rawModels) {
	let grafCount = 3; // бодрый я, пожалуйста, разберись почему когда я пишу эту переменную в глобальной среде - оно не жрет в цикле фор???
					// сообщение от бодрого меня - нет, не разберусь :)
	print("starting registering grafs");
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {

		entry = it.next();
		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		entry.getValue().applyUVMirror(false, true);
		result[jsStringKey] = {}
		let og = ModelManager.uploadVertArrays(entry.getValue());
		for (let i = 0; i < grafCount; i++) {
			let copy = og.copyForMaterialChanges();
			copy.replaceAllTexture(Resources.idRelative("mtr:f79/grafs/"+i+".png"))
			result[jsStringKey]["" + i] = copy;

		}
		print(jsStringKey)
		
		
	}
	
	return result;
}

function create(ctx, state, train) {

	initRoll(train, state);
	//displCreate(ctx, state, train);
	initRocking(train, state);

	state.postCreateFunctionCalled = false;

	state.wipeCoef = 0.0;
	state.wipeReverseMark = 0; // метка для плавного переключения дворников

	state.extDoorLightTimer = 0.0;
	state.extDoorLightFlag = false;
	state.oldDoorVal = train.doorValue();
	state.extDoorLightLeftMemory = new Array(train.trainCars());
	state.extDoorLightRightMemory = new Array(train.trainCars());

	state.hasGraf = false;
	state.number = Math.abs(train.id() % 1000) + 2000; // default value

	state.grafTypes = [];
	state.grafShouldBeArray = [];

	for (let i = 0; i < train.trainCars(); i++) {
		// door memory
		state.extDoorLightLeftMemory[i] = train.doorLeftOpen[i];
		state.extDoorLightRightMemory[i] = train.doorRightOpen[i];

		// graffity vars
		state.grafTypes[i] = 0;
		state.grafShouldBeArray[i] = false;
	}

	state.windows = new Array(train.trainCars());
    for (let i = 0; i < train.trainCars(); i++) {
        state.windows[i] = new Array(8);
        for (let j = 0; j < 8; j++) {
            state.windows[i][j] = Math.random() >= 0.5;
        }
    }
}


function dispose(ctx, state, train) {

}

function render(ctx, state, train) {
	setPostcreateInfo(ctx, state, train); // train.siding() при вызове в функции create возвращает null, поэтому нужна доп. проверка.
	updateLogic(state, train);
	renderLogic(ctx, state, train);
}



function setPostcreateInfo(ctx, state, train) {
	if (!state.postCreateFunctionCalled) {
		
		if (train.siding() == null) {
			return;
		}

		let infoArr = train.siding().name.split('\\|');
		let num = parseInt("" + infoArr[1]);
		let graf = infoArr[2] == '1';

		//let grafCount = 3; 
	
		state.hasGraf = graf;
		state.number = isNaN(num) ? state.number : num;
		state.grafTypes = [];
		state.grafShouldBeArray = [];
		
		var rand = new java.util.Random(train.id());
		for (var i = 0; i < train.trainCars(); i++) {
			if (Math.abs(rand.nextInt()) % 4 == 0) {
				state.grafShouldBeArray[i] = false;
			} else {
				state.grafShouldBeArray[i] = true;
				state.grafTypes[i] = Math.abs(rand.nextInt()) % grafCount;
			}
			
		}
		
		state.postCreateFunctionCalled = true;
	}
}

function updateLogic(state, train) {
	updateRoll(train, state, -0.5);
	updateRocking(train, state, 140, 88, 20, 27);
	updateWipers(train, state);
	updateExtLights(train, state);
}

function updateExtLights(train, state) {
	if (train.doorValue() > 0.0 && train.doorValue() < 1.0 && state.oldDoorVal > train.doorValue()) {
		if (!state.extDoorLightFlag) {
			state.extDoorLightTimer = 9.0;
			for (let i = 0; i < train.trainCars(); i++) {
				state.extDoorLightLeftMemory[i] = train.doorLeftOpen[i];
				state.extDoorLightRightMemory[i] = train.doorRightOpen[i];
			}
		}
		state.extDoorLightFlag = true;
	}

	if (state.extDoorLightTimer > 0) {
		state.extDoorLightTimer -= Timing.delta();
	}

	if (state.extDoorLightTimer <= 0) {
		state.extDoorLightTimer = 0;
		state.extDoorLightFlag = false;
	} 

	state.oldDoorVal = train.doorValue();
}

function updateWipers(train, state) {
	let pos = train.lastCarPosition[0];
	let isRaining = MinecraftClient.worldIsRainingAt(pos);
	if (isRaining || state.wipeCoef > 0) {
		state.wipeCoef += Timing.delta() / 1.5;
		if (state.wipeCoef > 1.0) {
			state.wipeCoef = 0.0;
			state.wipeReverseMark = train.isReversed();
		}
	}
}

function renderLogic(ctx, state, train) {
	let matrices = new Matrices();

	for (var i = 0; i < train.trainCars(); i++) {
		renderCart(ctx, state, train, i, matrices, i % 2 == 1);
	}
}

function renderCart(ctx, state, train, i, matrices, isReversed) {
	let isGraf = state.hasGraf && state.grafShouldBeArray[i];
	let grafType = state.grafTypes[i] + "";

	let roll = state.rolls[i];
	roll = clamp(roll, -0.05, 0.05);

	//print(roll + " " + i);


	let speedKmph = train.speed() * 20 * 3.6;

	let speedCoef = speedKmph > 20.0 ? 1.0 : speedKmph / 40 + 0.5;

	let rockZ = (state.rockingZCoef +  0.2 * i) % 1.0;
	let rockX = (state.rockingXCoef +  0.2 * i) % 1.0;

	let totalZrotation = speedCoef * chaoticRotate2(rockZ) * 3 + roll;
	let totalXrotation = speedCoef * chaoticRotate(rockX) * 0.5;

	let doorValue = train.doorValue();
	let doorValueClamped = clamp(train.doorValue() * 1.7, 0, 1);
	let doorValFin = 0.0;

	let trainReversed = train.isReversed();
	let isFrontCar = i == 0;
	let isBackCar = (i == train.trainCars() - 1) && (i % 2 == 1);


	if (train.isDoorOpening()) {
		doorValFin = doorValueClamped;
	} else {
		doorValFin = getDoorValFin(doorValueClamped);
	}

	// BOGIES
	
	matrices.pushPose();
	matrices.translate(0, -0.5, 5);
	ctx.drawCarModel(bogieModel["main"], i, matrices);
	matrices.popPose();



	matrices.pushPose();
	matrices.translate(0, -0.5, -5);
	matrices.rotateY(3.141592);
	ctx.drawCarModel(bogieModel["main"], i, matrices);
	matrices.popPose();

	matrices.pushPose(); // pushing for rocking and roll
	matrices.rotateZ(totalZrotation);
	matrices.rotateX(totalXrotation);

	matrices.pushPose(); // pushing for rotating by 180 deg.

	if (isReversed) {
		matrices.rotateY(3.1415);
	}

	// DISPLAY
	if (i == 0 || i == train.trainCars() - 1) {
		ctx.drawCarModel(state.dh.model, i, matrices);
	}

	// NUMBER
	let firstNum = Math.floor(state.number / 1000) * 1000;
	let num = firstNum + ((state.number + i) % 1000);

	matrices.pushPose();
	matrices.translate(0, 0.4, 7.64);
	numRender(ctx, train, state, matrices, 0.15, i, num)
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(1.32, 0.4, 6.95);
	matrices.rotateY(3.1415/2);
	numRender(ctx, train, state, matrices, 0.13, i, num)
	matrices.popPose();

	// EXTERIOR AND INTERIOR
	ctx.drawCarModel(models["ext"], i, matrices);
	ctx.drawCarModel(models["lamp"], i, matrices);
	ctx.drawCarModel(models["int"], i, matrices);

	if (isGraf) {
		ctx.drawCarModel(graffityModel["EXT"][grafType], i, matrices);
	}
	
	// WINDOWS
	for (var j = 1; j <= 8; j++) {
		let str = "openfort.00" + j;

		if (state.windows[i][j] == true) {
			ctx.drawCarModel(models[str], i, matrices);
			continue;
		}
		if (j < 5) {
			matrices.pushPose();
			matrices.translate(1.300, 1.532, 0);
			matrices.rotateZ(3.14 / 4);
			matrices.translate(-1.300, -1.532, 0);
			ctx.drawCarModel(models[str], i, matrices);
			matrices.popPose();
		} else {
			matrices.pushPose();
			matrices.translate(-1.300, 1.532, 0);
			matrices.rotateZ(-3.14 / 4);
			matrices.translate(1.300, -1.532, 0);
			ctx.drawCarModel(models[str], i, matrices);
			matrices.popPose();
		}

	}

	// DOORS
	let isLeftOpened = !isReversed? train.doorLeftOpen[i] : train.doorRightOpen[i];
	let isRightOpened = isReversed ? train.doorLeftOpen[i] : train.doorRightOpen[i];

	let leftVal = doorValFin * isLeftOpened;
	let rightVal = doorValFin * isRightOpened;

	matrices.pushPose();
	matrices.translate(0, 0, smoothCubic(leftVal) * 0.58);
	ctx.drawCarModel(models["doorLeftFront"], i, matrices);
	ctx.drawCarModel(models["doorLeftFrontInt"], i, matrices);

	if (isGraf) {
		ctx.drawCarModel(graffityModel["DOOREXT_1_LL"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_2_LL"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_3_LL"]["" + grafType], i, matrices);
	}
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0, 0, -smoothCubic(leftVal) * 0.58);
	ctx.drawCarModel(models["doorLeftBack"], i, matrices);
	ctx.drawCarModel(models["doorLeftBackInt"], i, matrices);

	if (isGraf) {
		ctx.drawCarModel(graffityModel["DOOREXT_1_LR"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_2_LR"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_3_LR"]["" + grafType], i, matrices);
	}
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0, 0, -smoothCubic(rightVal) * 0.58);
	ctx.drawCarModel(models["doorRightFront"], i, matrices);
	ctx.drawCarModel(models["doorRightFrontInt"], i, matrices);
	if (isGraf) {
		ctx.drawCarModel(graffityModel["DOOREXT_1_RR"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_2_RR"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_3_RR"]["" + grafType], i, matrices);
	}
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0, 0, smoothCubic(rightVal) * 0.58);
	ctx.drawCarModel(models["doorRightBack"], i, matrices);
	ctx.drawCarModel(models["doorRightBackInt"], i, matrices);
	if (isGraf) {
		ctx.drawCarModel(graffityModel["DOOREXT_1_RL"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_2_RL"]["" + grafType], i, matrices);
		ctx.drawCarModel(graffityModel["DOOREXT_3_RL"]["" + grafType], i, matrices);
	}
	matrices.popPose();
	// DOOR LIGHTS

	let shouldRenderL = !train.isDoorOpening() && doorValue < 1 && isLeftOpened && (doorValue % 0.15) > 0.08; 
	let shouldRenderR = !train.isDoorOpening() && doorValue < 1 && isRightOpened && (doorValue % 0.15) > 0.08; 

	let isLeftOpenedMem = !isReversed ? state.extDoorLightLeftMemory[i] : state.extDoorLightRightMemory[i];
	let isRightOpenedMem = isReversed ? state.extDoorLightLeftMemory[i] : state.extDoorLightRightMemory[i];

	let shouldRenderExtR = isRightOpenedMem && (state.extDoorLightTimer % 0.75) > 0.4 && state.extDoorLightFlag; 
	let shouldRenderExtL = isLeftOpenedMem && (state.extDoorLightTimer % 0.75) > 0.4 && state.extDoorLightFlag; 

	if (shouldRenderR) {
		ctx.drawCarModel(models["right_door_l"], i, matrices);
	}

	if (shouldRenderExtR) {
		ctx.drawCarModel(models["door_light_right"], i, matrices);
	}

	if (shouldRenderExtL) {
		ctx.drawCarModel(models["door_light_left"], i, matrices);
	}

	if (shouldRenderL) {
		ctx.drawCarModel(models["left_door_l"], i, matrices);
	}

	// WIPERS

	const wipZ = 0.9882;
	const wipX = 0.1530;



	let coef = (isFrontCar && !state.wipeReverseMark) || (isBackCar && state.wipeReverseMark) ? state.wipeCoef : 0.0;

	matrices.pushPose();
	matrices.translate(0.8487, 1.900, 7.590);
	matrices.rotate(wipX, 0, wipZ, -0.87 * wipFunc(coef));
	matrices.translate(-0.8487, -1.900, -7.590);
	{
		matrices.pushPose();
		matrices.translate(1.149, 1.357, 7.551);
		matrices.rotate(wipX, 0, wipZ, 0.87 * wipFunc(coef));
		matrices.translate(-1.149, -1.357, -7.551);
		ctx.drawCarModel(models["LW2"], i, matrices);
		matrices.popPose();
	}
	ctx.drawCarModel(models["LW"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(-0.8487, 1.900, 7.590);
	matrices.rotate(-wipX, 0, wipZ, 0.87 * wipFunc(coef));
	matrices.translate(0.8487, -1.900, -7.590);
	{
		matrices.pushPose();
		matrices.translate(-1.149, 1.357, 7.551);
		matrices.rotate(-wipX, 0, wipZ, -0.87 * wipFunc(coef));
		matrices.translate(1.149, -1.357, -7.551);
		ctx.drawCarModel(models["RW2"], i, matrices);
		matrices.popPose();
	}
	ctx.drawCarModel(models["RW"], i, matrices);
	matrices.popPose();

	// LIGHTS

	if (i == 0) {
		if (!trainReversed) {
			ctx.drawCarModel(models["front_light"], i, matrices);
		} else {
			ctx.drawCarModel(models["back_light"], i, matrices);
		}
	} else if (i == train.trainCars() - 1 && i % 2 == 1) {
		if (trainReversed) {
			ctx.drawCarModel(models["front_light"], i, matrices);
		} else {
			ctx.drawCarModel(models["back_light"], i, matrices);
		}
	}

	matrices.popPose();
	matrices.popPose();

}

function wipFunc(x) {
	return 0.5 * pseudoSin(x + 0.75) + 0.5;
}



function getDoorValFin(x) {
	let doorValFin = 0.0;
	if (x < 0.4) {
		return 0.3 * x;
	} else {
		return 22.0/15*x - 7/15;
	}
}

function chaoticRotate(x) {
	return (x)*(x-1)*(x-0.25)*(x-0.6)*(x-0.8);
}

function chaoticRotate2(x) {
	return (x)*(x-1)*(x-0.15)*(x-0.5)*(x-0.8);
}

