const numOfDigits = 4;
var rawModelsNums = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:number/nums_bvg.obj"), null);
var modelNum = uploadNumModels(rawModelsNums);

function numRenderHHeadFront(ctx, train, state, matrices, i) {
	let ind = (i + 1) % 10;
	let num = state.number % 10000;
	
	let idStr = num.toString().padStart(numOfDigits, '0');
	
	matrices.pushPose();
	matrices.translate(0.5756, 0.1469, 8.242);
	matrices.rotateY(0.0738);
	matrices.translate(-0.1, 0, 0);
	for (let j = 0; j < 3; j++){
		matrices.translate(0.1, 0, 0);
		ctx.drawCarModel(modelNum["" + idStr[j]], i, matrices);
	}
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0.8185, 0.1469, 8.224);
	matrices.rotateY(0.18);
	
	matrices.translate(0.066, 0, 0);
	ctx.drawCarModel(modelNum["" + idStr["3"]], i, matrices);
		
	matrices.translate(0.085, 0, 0);
	ctx.drawCarModel(modelNum["minus"], i, matrices);
	
	matrices.translate(0.095, 0, 0);
	ctx.drawCarModel(modelNum["" + ind], i, matrices);
	matrices.popPose();
}

function numRenderHHeadSide(ctx, train, state, matrices, i) {
	matrices.pushPose();
	matrices.translate(1.285, 0.1872, 7.625);
	matrices.rotateZ(-0.15)
	matrices.rotateY(Math.PI/2);
	numRenderHAtZero(ctx, train, state, matrices, i);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(-1.285, 0.1872, 7.17);
	matrices.rotateZ(0.15)
	matrices.rotateY(-Math.PI/2);
	numRenderHAtZero(ctx, train, state, matrices, i);
	matrices.popPose();
}

function numRenderHMid(ctx, train, state, matrices, i) {
	matrices.pushPose();
	matrices.translate(1.26, 0.06102, -7.366);
	matrices.rotateZ(-0.17)
	matrices.rotateY(Math.PI/2);
	numRenderHAtZero(ctx, train, state, matrices, i);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(-1.26, 0.06102, -7.866);
	matrices.rotateZ(0.17)
	matrices.rotateY(-Math.PI/2);
	numRenderHAtZero(ctx, train, state, matrices, i);
	matrices.popPose();
}


function numRenderHAtZero(ctx, train, state, matrices, i) {
	let ind = (i + 1) % 10;
	let num = state.number % 10000;
	
	let idStr = num.toString().padStart(numOfDigits, '0');
	
	matrices.pushPose();
	matrices.translate(-0.1, 0, 0);
	for (let j = 0; j < 4; j++){
		matrices.translate(0.1, 0, 0);
		ctx.drawCarModel(modelNum["" + idStr[j]], i, matrices);
	}
	matrices.translate(0.1, 0, 0);
	ctx.drawCarModel(modelNum["minus"], i, matrices);
	matrices.translate(0.1, 0, 0);
	ctx.drawCarModel(modelNum["" + ind], i, matrices);
	matrices.popPose();


}


function uploadNumModels(rawModels) { 
  result = {};
  for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
    entry = it.next();

    let jsStringKey = "" + entry.getKey(); 
    entry.getValue().applyUVMirror(false, true);
    result["" + jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
  }
  return result;
}